Install environment
===
```bash
conda env create -f env.yml
conda activate torch1.5
```
Data
===
 - download data at: https://www.dropbox.com/sh/tjyjegn05qujm7k/AAB1la3f92U8sr7Aer1jOFEaa?dl=0
 - save to "data" folder: data/mnist/MNIST/...

Run experiments
===
- Each experiment includes 2-4 sub-experiments, the output of a sub-experiment include:
    - models
    - generated images
    - csv report and logs files
- Once all sub-experiment have completed, a final report is generated to visualize the results in comparison

- Some notations use in the experiments:

![alt text](images/notations.png)

Exp1: spetral norm gan1
---
```bash
./run_spectral_norm_gan1.sh
```
Exp2: uniform noise and change Bz
---
- gan1
```bash
./run_uniform_bz_gan1.sh
```
Exp3: Change &sigma; in translation augmentation
---
- gan1
```bash
./run_augmentation_gan1.sh
```
